/* ****************************************************************************
* :      Unicode
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <wchar.h>
#include <stdio.h>
#include <locale.h>
#include <stdlib.h>
#include <string.h>

/*
         Unicode     :
   http://www.unicode.org/charts/PDF/U0400.pdf
*/   

/*         
    scanf()  wscanf().    .
           . 
     wscanf()    WSCANF  
   :
   
   gcc -DWSCANF -o prg18 prg18.c
*/

/*      : 

   LANG=ru_RU.KOI8-R ./prg
   
       ,       
      .
*/

//  
char *check_orientation( FILE *stream );
void print_bytes( FILE *stream, const char *str, int count );

int main( void )
{
  wchar_t wc = L'';                    //   
  wchar_t wstr[] = L" wchar_t";  //   

  //      UTF-8,     
  // , , '', ..    UTF-8  
  // 
  char ch = 'D';                        //   ()

  //       char   ,  
  //   ,      
  // (       ,    
  //  ,  )
  char str[] = " char";          //   ("" )

  char conv[ 256 ];      //     
                         //       
                         // 
  int num_bytes;         //      

  //       , 
  //    
  if ( !setlocale( LC_CTYPE, "" ) )
  {
    fprintf( stderr, "Can't set locale LC_CTYPE\n" );
    exit( 1 );
  }

/*#if defined( __STDC_ISO_10646__ )
    printf( "__STDC_ISO_10646__\n" );
  #endif
*/
  //          (wide
  // characters)    .

  //     stdin, stdout  stderr
  printf( "  stdout: %s\n", check_orientation( stdout ) );
  printf( "  stdin: %s\n", check_orientation( stdin ) );
  printf( "  stderr: %s\n", check_orientation( stderr ) );

  printf( "     wchar_t = %d\n", sizeof( wchar_t ) );

  printf( "\n    ( ) "
          "       \n" );  

  //      stderr (   
  //  )
  if ( fwide( stderr, 1 ) != 1 )
    printf( "    stderr   \n" );

  printf( "  stderr: %s\n", check_orientation( stderr ) );

  fwprintf( stderr, L" : %lc\n", wc );
  fwprintf( stderr, L"  : %ls\n", wstr );
  fwprintf( stderr, L"  :   - %d\n",
            wcslen( wstr ) );

  //      
  // (      wcslen(),   strlen(),
  //          )
  print_bytes( stdout, ( char * )wstr, wcslen( wstr ) * sizeof( wchar_t ) );
  
  fwprintf( stderr, L" : %c\n", ch );
  fwprintf( stderr, L"  : %s\n", str );
  fwprintf( stderr, L"  :  - %d\n", strlen( str ) );

  //      
  // (      strlen())
  print_bytes( stdout, str, strlen( str ) );

  //         
  num_bytes = wctomb( conv, wc );
  conv[ num_bytes ] = '\0';  //   fwprintf ,   
  fwprintf( stderr, L"  : %s\n", conv );

  //          
  // (      )
  if ( wcstombs( conv, wstr, 256 ) == -1 )
    printf( "     \n" );
  else
    fwprintf( stderr, L"   : %s\n",
              conv );
  

  printf( "\n    ( ) "
          "       \n" );

  //  stdout     , ..   
  //  printf(),   -
  // .       .

  printf( "  stdout: %s\n", check_orientation( stdout ) );

  fprintf( stdout, " : %lc\n", wc );
  fprintf( stdout, "  : %ls\n", wstr );

  fprintf( stdout, " : %c\n", ch );
  fprintf( stdout, "  : %s\n", str );

  printf( "\n    ( ) "
          "       \n" );

  printf( "  stdin: %s\n", check_orientation( stdin ) );

#ifdef WSCANF
  printf( "\n  wscanf()\n" );
  printf( "\n \n" );

  printf( " : " );
  wscanf( L"%ls", wstr );
  wscanf( L"%*[^\n]" );       //   ,
  wscanf( L"%*c" );           //      
  fprintf( stdout, "  : %ls\n", wstr );

  //      
  // (      wcslen(),   strlen(),
  //          )
  print_bytes( stdout, ( char * )wstr, wcslen( wstr ) * sizeof( wchar_t ) );

  printf( " : " );
  wscanf( L"%lc", &wc );
  fprintf( stdout, " : %lc\n", wc );

  printf( "\n \n" );

  printf( " : " );
  wscanf( L"%s", str );
  wscanf( L"%*[^\n]" );       //   ,
  wscanf( L"%*c" );           //      
  fprintf( stdout, "  : %s\n", str );

  //      
  // (      strlen())
  print_bytes( stdout, str, strlen( str ) );

  printf( "  : " );
  wscanf( L"%c", &ch );
  fprintf( stdout, " () : %c\n", ch );
#else
  printf( "\n  scanf()\n" );
  printf( "\n \n" );

  printf( " : " );
  scanf( "%ls", wstr );
  scanf( "%*[^\n]" );       //   ,
  scanf( "%*c" );           //      
  fprintf( stdout, "  : %ls\n", wstr );

  //      
  // (      wcslen(),   strlen(),
  //          )
  print_bytes( stdout, ( char * )wstr, wcslen( wstr ) * sizeof( wchar_t ) );

  printf( " : " );
  scanf( "%lc", &wc );
  fprintf( stdout, " : %lc\n", wc );

  printf( "\n \n" );

  printf( " : " );
  scanf( "%s", str );
  scanf( "%*[^\n]" );       //   ,
  scanf( "%*c" );           //      
  fprintf( stdout, "  : %s\n", str );

  //      
  // (      strlen())
  print_bytes( stdout, str, strlen( str ) );

  printf( "  : " );
  scanf( "%c", &ch );
  fprintf( stdout, " () : %c\n", ch );
#endif

  return 0;
}


/*
      :    .
*/

char *check_orientation( FILE *stream )
{
  //  stream --   (stdin, stdout, stderr)

  int stream_orientation;

  /*        return   str,
         static,    
       .     
       ,        .
         static    --
       .
  */ 
  static char str[ 80 ];
  
  //    
  stream_orientation = fwide( stream, 0 );

  //     
  if ( stream_orientation > 0 )
    sprintf( str, "  (%d)", stream_orientation );
  else if ( stream_orientation < 0 )
    sprintf( str, " (%d)", stream_orientation );
  else
    sprintf( str, "  (%d)", stream_orientation );

  return str;
}

/*
          .
*/
void print_bytes( FILE *stream, const char *str, int count )
{
  // :
  // stream --   (stdout, stderr)
  // str --    
  // count --   (  )

  int i;
  
  for ( i = 0; i < count; i++ )
  {
    /*       unsigned char,   
           (     int).
            unsigned int ,   
         7  ,      ,
        char  int.       FF. 
    */ 
    //  %02X :   ,  ,
    //   ,     
    fprintf( stream, "(%3d: %02X) ", i,
             ( unsigned int )( unsigned char )*( str + i ) );
  }
  fprintf( stream, "\n" );

  return;
}
