/* ****************************************************************************
* :  
* :        
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//      strlen()
#include <string.h>

//    
#include <wchar.h>

#include "students.h"


//   static ,      
//  ,      .  
//         .
//    ,       ,
//    , ,  .
static int add( void );
static int find( void );
static int list( void );
static int delete( void );
static int update( void );


//    GROUP
//         0, . . 
//     '\0' (     
//     groups.db   ,  ""
//  ASCII-  ,    )
static GROUP grp;

/* ****************************************************************************
*        
* ****************************************************************************/
void groups( void )
{
  char answer;     //      

  printf( "\n  \n" );

  //   answer  ,    
  //  
  answer = '1';

  while ( answer == '1' || answer == '2' || answer == '3' || 
          answer == '4' || answer == '5' )
  {
    printf( "\n" );              //  
    printf( "1.   \n" );
    printf( "2.    \n" );
    printf( "3.   \n" );
    printf( "4.   \n" );
    printf( "5.   \n" );
    printf( "6.     \n\n" );

    printf( " : " );
    scanf( "%c", &answer );      //     ,   
    printf( "\n" );              //  

    //   
    while ( getchar() != '\n' )
      continue;

    if ( answer == '1' )
    {
      list();
    }
    else if ( answer == '2' )
    {
      add();
    }
    else if ( answer == '3' )
    {
      update();
    }
    else if ( answer == '4' )
    {
      delete();
    }
    else if ( answer == '5' )
    {
      find();
    }
    else if ( answer == '6' )
    {
      return;
    }
    else    //  -  
    {
//      clrscr();      //  
      printf( "    \n" );

      //   answer  ,    
      //   
      answer = '1';
    }
  }
  return;
}


/* ****************************************************************************
*     
* ****************************************************************************/
static int add( void )
{
#ifdef UTF8
  wchar_t answer;  //     
#else
  char answer;     //     
#endif

  int written;     //    ,    

  //     
  FILE *out;

  //         
  //    (    "db",   database)
  out = fopen( "groups.db", "ab" );

  //    ()  ,     NULL
  if ( out == NULL )
  {
    fprintf( stderr, "    groups.db\n" );
    return 1;   //   ,   
  }

  printf( "   \n\n" );

  //   answer  ,    
  //  
  answer = YES;

  while ( answer == YES )
  {
    //       
    printf( "  (  %d   ): ",
            GROUP_CODE_LEN - 1 );
    scanf( "%s", grp.group_code );

    //   
    while ( getchar() != '\n' )
      continue;

    printf( "\n  (  %d ): ", GROUP_DESCR_LEN - 1 );
    gets( grp.group_descr );

    //   "  "   '\0', . . 
    //        , ,  
    //   
    grp.deleted = '\0';

    //        , . .  gets()
    //    '\n'  
    //        ,
    //        
    // while ( getchar() != '\n' )
    //   continue;

    //      groups.db
    written = fwrite( &grp, sizeof( grp ), 1, out );

    if ( written != 1 )
      printf( "      groups.db\n" );

    //   ,     , , 
    //   ,       "",
    //       -  ,   ""
    // (     ,   )

    //   answer  ,    
    //  
    answer = '\0';

    while ( answer != YES && answer != NO )
    {
      printf( "\n   (/) ?: " );
      scanf( FORMAT, &answer );

      //   
      while ( getchar() != '\n' )
        continue;

    }
  }  
  
  //  
  fclose( out );

  return;
}


/* ****************************************************************************
*        groups.db
* ****************************************************************************/
static int delete( void )
{
  int  written;    //    ,    

  //     
  char grp_code[ GROUP_CODE_LEN ];

  char deleted_mark = '*';  //   
  int found = 0;            //  ,     
 
  //     
  FILE *groups;

  //        
  groups = fopen( "groups.db", "r+b" );

  //    
  if ( groups == NULL )
  {
    fprintf( stderr, "    groups.db\n" );
    return 1;   //   ,   
  }

  printf( "  \n\n" );

  printf( "    \n" \
          "(  %d   ): ", GROUP_CODE_LEN - 1 );
  scanf( "%s", grp_code );

  //   
  while ( getchar() != '\n' )
    continue;

  printf( "\n" );   //    

  //     ,    
  while ( fread( &grp, sizeof( grp ), 1, groups ) == 1 )
  {
    //      
    if ( grp.deleted )
      continue;    //    , . .   

    //        , 
    //      
    if ( strcmp( grp_code, grp.group_code ) == 0 )
    {
      found = 1;    //   --    

      //          ()
      //  SEEK_CUR ,    
      //      ;  "-"  
      //    
      fseek( groups, -( sizeof( grp ) ), SEEK_CUR );

      //         groups.db
      written = fwrite( &deleted_mark, 1, 1, groups );

      if ( written == 1 )
        printf( " \n" );
      else
        printf( "      groups.db\n" );

      break;      //   , . .    
    }
  }

  //    : if ( found == 0 )
  if ( !found )  //        
    printf( "  \n" );

  //  
  fclose( groups );

  return 0;        //   
}


/* ****************************************************************************
*       groups.db
* ****************************************************************************/
static int find( void )
{
  //     
  char grp_code[ GROUP_CODE_LEN ];

  int found = 0;            //  ,     
 
  //     
  FILE *groups;

  //     
  groups = fopen( "groups.db", "rb" );

  //    
  if ( groups == NULL )
  {
    fprintf( stderr, "    groups.db\n" );
    return 1;   //   ,   
  }

  printf( "  \n\n" );

  printf( "    \n" \
          "(  %d   ): ", GROUP_CODE_LEN - 1 );
  scanf( "%s", grp_code );

  //   
  while ( getchar() != '\n' )
    continue;

  printf( "\n" );   //    

  //     ,    
  while ( fread( &grp, sizeof( grp ), 1, groups ) == 1 )
  {
    //      
    if ( grp.deleted )
      continue;    //    , . .   

    //        , 
    //      
    if ( strcmp( grp_code, grp.group_code ) == 0 )
    {
      found = 1;    //   --    

      //     
      printf( "%s %s\n", grp.group_code, grp.group_descr );

      break;        //   , . .    
    }
  }

  //    : if ( found == 0 )
  if ( !found )  //        
    printf( "   %s    groups.db\n", grp_code );

  //  
  fclose( groups );

  return 0;        //   
}


/* ****************************************************************************
*     
* ****************************************************************************/
static int list( void )
{
  int written;     //    ,    
  int i;           //    

  //     
  FILE *in;

  //          
  in = fopen( "groups.db", "rb" );

  //    
  if ( in == NULL )
  {
    fprintf( stderr, "    groups.db\n" );
    return 1;      //   
  }

  printf( "  \n\n" );

  //       groups.db   
  // (. .   )

  i = 1;   //      

  while ( fread( &grp, sizeof( grp ), 1, in ) == 1 )
  {
    //         (. .  
    // deleted    )...
    if ( ! grp.deleted )
    {
      // ...      
      printf( "%d. %s %s\n", i, grp.group_code, grp.group_descr );
      i++;
    }
  }

  //  
  fclose( in );

  return 0;
}


/* ****************************************************************************
*        groups.db
* ****************************************************************************/
static int update( void )
{
  int  written;    //    ,    

  char grp_code[ GROUP_CODE_LEN ];      //   
  char grp_descr[ GROUP_DESCR_LEN ];    //  

  int found = 0;            //  ,     
  int updated = 0;          //  ,     

  //     
  FILE *groups;

  //        
  groups = fopen( "groups.db", "r+b" );

  //    
  if ( groups == NULL )
  {
    fprintf( stderr, "    groups.db\n" );
    return 1;   //   ,   
  }

  printf( "  \n\n" );

  printf( "    \n" \
          "(  %d   ): ", GROUP_CODE_LEN - 1 );
  scanf( "%s", grp_code );

  //   
  while ( getchar() != '\n' )
    continue;

  printf( "\n" );   //    

  //     ,    
  while ( fread( &grp, sizeof( grp ), 1, groups ) == 1 )
  {
    //      
    if ( grp.deleted )
      continue;    //    , . .   

    //         , 
    //      
    if ( strcmp( grp_code, grp.group_code ) != 0 )
      continue;    //    , . .   

    found = 1;     //   --    

    //       
    printf( "%s   %s\n\n", grp.group_code, grp.group_descr );

    //    
    printf( "      .\n" \
            "     , " \
            "   Enter\n\n");

    //       
    printf( "  (  %d   ): ",
            GROUP_CODE_LEN - 1 );
    gets( grp_code );

    printf( "\n  (  %d ): ", GROUP_DESCR_LEN - 1 );
    gets( grp_descr );

    printf( "\n" );   //    

    //        , . .  gets()
    //    '\n'  
    //        ,
    //        
    // while ( getchar() != '\n' )
    //   continue;

    //       " "
    if ( strlen( grp_code ) != 0 )
    {
      //      
      strcpy( grp.group_code, grp_code );
      updated = 1;                       //  --  
    }

    //       " "
    if ( strlen( grp_descr ) != 0 )
    {
      //      
      strcpy( grp.group_descr, grp_descr );
      updated = 1;                        //  --  
    }

    //           
    if ( updated )   //     : if ( updated == 1 )
    {
      //          ()
      //  SEEK_CUR ,    
      //      ;  "-"  
      //    
      fseek( groups, -( sizeof( grp ) ), SEEK_CUR );

      //      groups.db
      written = fwrite( &grp, sizeof( grp ), 1, groups );

      if ( written == 1 )
        printf( " \n" );
      else
        printf( "      groups.db\n" );
    }
    else         // . . updated == 0
    {
      printf( "  , . .     \n" );
    }
    
    break;      //   , . .    
  }

  //    : if ( found == 0 )
  if ( !found )  //        
    printf( "  \n" );

  //  
  fclose( groups );

  return 0;        //   
}
