/* ****************************************************************************
* :  
* :        
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//      strlen()
#include <string.h>

//    
#include <wchar.h>

#include "students.h"


//   static ,      
//  ,      .  
//         .
//    ,       ,
//    , ,  .
static int add( void );
static int find( void );
static int list( void );
static int delete( void );
static int update( void );


//    STUDENT
//         0, . . 
//     '\0' (     
//     students.db   ,  ""
//  ASCII-  ,    )

//    ,     
static STUDENT student;


/* ****************************************************************************
*        
* ****************************************************************************/
void lists( void )
{
  char answer;     //      

  printf( "\n  \n" );

  //   answer  ,    
  //  
  answer = '1';

  while ( answer == '1' || answer == '2' || answer == '3' || 
          answer == '4' || answer == '5' )
  {
    printf( "\n" );              //  
    printf( "1.   \n" );
    printf( "2.   \n" );
    printf( "3.   \n" );
    printf( "4.   \n" );
    printf( "5.   \n" );
    printf( "6.     \n\n" );

    printf( " : " );
    scanf( "%c", &answer );      //     ,   
    printf( "\n" );              //  

    //   
    while ( getchar() != '\n' )
      continue;

    if ( answer == '1' )
    {
      list();
    }
    else if ( answer == '2' )
    {
      add();
    }
    else if ( answer == '3' )
    {
      update();
    }
    else if ( answer == '4' )
    {
      delete();
    }
    else if ( answer == '5' )
    {
      find();
    }
    else if ( answer == '6' )
    {
      return;
    }
    else    //  -  
    {
      printf( "    \n" );

      //   answer  ,    
      //   
      answer = '1';
    }
  }
  return;
}


/* ****************************************************************************
*   
* ****************************************************************************/
static int add( void )
{
  //      ,    
  //    
  //     static     
  //   ,    
  static int count_students = 0;
  
#ifdef UTF8
  wchar_t answer;  //     
#else
  char answer;     //     
#endif

  int written;     //    ,    

  //     
  FILE *out;

  //         
  //    (    "db",   database)
  out = fopen( "students.db", "ab" );

  //    ()  ,     NULL
  if ( out == NULL )
  {
    fprintf( stderr, "    students.db\n" );
    return 1;   //   ,   
  }

  printf( "  \n\n" );

  //   answer  ,    
  //  
  answer = YES;

  while ( answer == YES )
  {
    //       
    printf( "  (  %d   ): ",
            GROUP_CODE_LEN - 1 );
    gets( student.group_code );

    printf( "\n (  %d ): ", NAME_LEN - 1 );
    gets( student.last_name );

    printf( "\n (  %d ): ", NAME_LEN - 1 );
    gets( student.first_name );

    printf( "\n ( ): " );
    scanf( "%d", &student.height );

    printf( "\n ( ) " \
            "(    \".\"): " );
    scanf( "%f", &student.weight );

    //   
    while ( getchar() != '\n' )
      continue;
 
    //   "  "   '\0', . . 
    //        , ,  
    //   
    student.deleted = '\0';

    //      students.db
    written = fwrite( &student, sizeof( student ), 1, out );

    if ( written != 1 )
      printf( "      students.db\n" );
    else
      printf( "        %d  "
              " \n", ++count_students );
      
    //   ,     , , 
    //   ,       "",
    //       -  ,   ""
    // (     ,   )

    //   answer  ,    
    //  
    answer = '\0';

    while ( answer != YES && answer != NO )
    {
      printf( "\n   (/) ?: " );
      scanf( FORMAT, &answer );

      //   
      while ( getchar() != '\n' )
        continue;

    }
  }  
  
  //  
  fclose( out );

  return;
}


/* ****************************************************************************
*       students.db
* ****************************************************************************/
static int delete( void )
{
  int  written;    //    ,    

  //     
  char grp_code[ GROUP_CODE_LEN ];

  //    
  char last_name[ NAME_LEN ];

  char deleted_mark = '*';  //   
  int found = 0;            //  ,     
 
  //     
  FILE *students;

  //        
  students = fopen( "students.db", "r+b" );

  //    
  if ( students == NULL )
  {
    fprintf( stderr, "    students.db\n" );
    return 1;   //   ,   
  }

  printf( "  \n\n" );

  printf( "    \n" \
          "(  %d   ): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n   (  %d ): ", NAME_LEN - 1 );
  gets( last_name );

  printf( "\n" );   //    

  //     ,    
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    //      
    if ( student.deleted )
      continue;    //    , . .   

    //         
    //  ,       
    if ( strcmp( grp_code, student.group_code ) == 0 && 
         strcmp( last_name, student.last_name ) == 0
       )
    {
      found = 1;    //   --    

      //          ()
      //  SEEK_CUR ,    
      //      ;  "-"  
      //    
      fseek( students, -( sizeof( student ) ), SEEK_CUR );

      //         students.db
      written = fwrite( &deleted_mark, 1, 1, students );

      if ( written == 1 )
        printf( " \n" );
      else
        printf( "      students.db\n" );

      break;      //   , . .    
    }
  }

  //    : if ( found == 0 )
  if ( !found )  //        
    printf( "     \n" );

  //  
  fclose( students );

  return 0;        //   
}


/* ****************************************************************************
*       students.db
* ****************************************************************************/
static int find( void )
{
  //     
  char grp_code[ GROUP_CODE_LEN ];

  //    
  char last_name[ NAME_LEN ];

  int found = 0;            //  ,     
 
  //     
  FILE *students;

  //     
  students = fopen( "students.db", "rb" );

  //    
  if ( students == NULL )
  {
    fprintf( stderr, "    students.db\n" );
    return 1;   //   ,   
  }

  printf( "  \n\n" );

  printf( "    \n" \
          "(  %d   ): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n   (  %d ): ", NAME_LEN - 1 );
  gets( last_name );

  printf( "\n" );   //    

  //     ,    
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    //      
    if ( student.deleted )
      continue;    //    , . .   

    //         
    //  ,       
    if ( strcmp( grp_code, student.group_code ) == 0 && 
         strcmp( last_name, student.last_name ) == 0
       )
    {
      found = 1;    //   --    

      //     
      printf( "%s %s %s %d %.2f\n", student.group_code, student.last_name,
                                    student.first_name, student.height,
                                    student.weight );

      break;        //   , . .    
    }
  }

  //    : if ( found == 0 )
  if ( !found )  //        
    printf( "     \n" );

  //  
  fclose( students );

  return 0;        //   
}


/* ****************************************************************************
*     
* ****************************************************************************/
static int list( void )
{
  int written;     //    ,    
  int i;           //    

  int found = 0;   //  ,     

  //     
  char grp_code[ GROUP_CODE_LEN ];

  //     
  FILE *students;

  //          
  students = fopen( "students.db", "rb" );

  //    
  if ( students == NULL )
  {
    fprintf( stderr, "    students.db\n" );
    return 1;      //   
  }

  printf( "  \n\n" );

  printf( "    \n" \
          "(  %d   ): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n" );   //    

  printf( "  %s\n\n", grp_code );

  i = 1;   //      

  //       students.db   
  // (. .   )
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    //      
    if ( student.deleted )
      continue;    //    , . .   

    //        , 
    //      
    if ( strcmp( grp_code, student.group_code ) == 0 )
    {
      found = 1;    //   --    

      //     
      //   student.group_code    --  
      printf( "%d. %s %s %d %.2f\n", i,
                                     student.last_name,
                                     student.first_name,
                                     student.height,
                                     student.weight );
      i++;
    }
  }

  //    : if ( found == 0 )
  if ( !found )  //        
    printf( "  \n" );

  //  
  fclose( students );

  return 0;
}


/* ****************************************************************************
*        students.db
* ****************************************************************************/
static int update( void )
{
  int  written;    //    ,    

  char  grp_code[ GROUP_CODE_LEN ];    //   
  char  last_name[ NAME_LEN ];         // 
  char  first_name[ NAME_LEN ];        // 
  char  height[ 5 ];                   //  ( )
  char  weight[ 7 ];                   //  ( )

  int found = 0;            //  ,     
  int updated = 0;          //  ,     

  //     
  FILE *students;

  //        
  students = fopen( "students.db", "r+b" );

  //    
  if ( students == NULL )
  {
    fprintf( stderr, "    students.db\n" );
    return 1;   //   ,   
  }

  printf( "  \n\n" );

  printf( "    \n" \
          "(  %d   ): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n   (  %d ): ", NAME_LEN - 1 );
  gets( last_name );

  printf( "\n" );   //    

  //     ,    
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    //      
    if ( student.deleted )
      continue;    //    , . .   

    //        
    //    ,       
    // ( "||"   "")
    if ( strcmp( grp_code, student.group_code ) != 0 || 
         strcmp( last_name, student.last_name ) != 0 )
      continue;    //    , . .   

    found = 1;     //   --    

    //         
    printf( "%s %s %s %d %.2f\n\n", student.group_code, student.last_name,
                                    student.first_name, student.height,
                                    student.weight );

    //    
    printf( "   .\n" \
            "     , " \
            "   Enter\n\n");

    //       
    printf( "  (  %d   ): ",
            GROUP_CODE_LEN - 1 );
    gets( grp_code );

    printf( "\n (  %d ): ", NAME_LEN - 1 );
    gets( last_name );

    printf( "\n (  %d ): ", NAME_LEN - 1 );
    gets( first_name );

    printf( "\n ( ): " );
    gets( height );

    printf( "\n ( ) " \
            "(    \".\"): " );
    gets( weight );

    printf( "\n" );   //    

    //       " "
    if ( strlen( grp_code ) != 0 )
    {
      //      
      strcpy( student.group_code, grp_code );
      updated = 1;                       //  --  
    }

    //       ""
    if ( strlen( last_name ) != 0 )
    {
      //      
      strcpy( student.last_name, last_name );
      updated = 1;                        //  --  
    }

    //       ""
    if ( strlen( first_name ) != 0 )
    {
      //      
      strcpy( student.first_name, first_name );
      updated = 1;                        //  --  
    }

    //       ""
    if ( strlen( height ) != 0 )
    {
      //      
      //  sscanf()    
      sscanf( height, "%d", &student.height );
      updated = 1;                        //  --  
    }

    //       ""
    if ( strlen( weight ) != 0 )
    {
      //      
      sscanf( weight, "%f", &student.weight );
      updated = 1;                        //  --  
    }

    //           
    if ( updated )   //     : if ( updated == 1 )
    {
      //          ()
      //  SEEK_CUR ,    
      //      ;  "-"  
      //    
      fseek( students, -( sizeof( student ) ), SEEK_CUR );

      //      students.db
      written = fwrite( &student, sizeof( student ), 1, students );

      if ( written == 1 )
        printf( " \n" );
      else
        printf( "      students.db\n" );
    }
    else         // . . updated == 0
    {
      printf( "  , . .     \n" );
    }
    
    break;      //   , . .    
  }

  //    : if ( found == 0 )
  if ( !found )  //        
    printf( "     \n" );

  //  
  fclose( students );

  return 0;        //   
}
