/* ****************************************************************************
* :    ( )
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//  
void bytes_to_bits( const char *bytes, int count, unsigned short mode );

//     bytes_to_bits()
#define PRINT_NUM_BYTE           1  //    : 00000001
#define PRINT_ADDRESS_BYTE       2  //    :  00000010
#define PRINT_ONE_BYTE_PER_LINE  4  //    : 00000100


int main( void )
{
  unsigned char ch;
  short int short_var;
  int int_var;
  float float_var;
  double double_var;

  unsigned char str[ 80 ];

  //        ,
  //      0b ( 16   , 
  // . .  short -- 16-)
  // .      , 
  //   (  ):
  // unsigned short int val = 0xAAAA;
  unsigned short int val = 0b1010101010101010;
  unsigned short int new_val;

  unsigned short int left_val = 12345;
  unsigned short int right_val = 54321;

  //        bytes_to_bits().
  //       "".
  unsigned short int mode = PRINT_NUM_BYTE | PRINT_ADDRESS_BYTE |
                            PRINT_ONE_BYTE_PER_LINE;
  // unsigned short int mode = PRINT_NUM_BYTE;

  printf( "         ,\n" \
          "..     .\n\n" );

  printf( "!        \n" \
          "   .    --  \n" \
          " .\n\n" );

  /* 
       
  */

  printf( "  \"~\" (  )\n" );
  printf( "  ( )\n" );
  bytes_to_bits( ( char * )&val, sizeof( short int ), mode );
  
  new_val = ~val;
  printf( " \n" );
  bytes_to_bits( ( char * )&new_val, sizeof( short int ), mode );

  /* *************************************************************************/

  printf( "\n \n" );
  printf( "   %d,  : ", left_val );
  bytes_to_bits( ( char * )&left_val, sizeof( short int ), mode );
  printf( "  %d,  : ", right_val );
  bytes_to_bits( ( char * )&right_val, sizeof( short int ), mode );

  printf( "\n \"\" (&)\n\n" );
  new_val = left_val & right_val;
  bytes_to_bits( ( char * )&new_val, sizeof( short int ), mode );
  printf( "\n" );

  printf( " \"\" (|)\n\n" );
  new_val = left_val | right_val;
  bytes_to_bits( ( char * )&new_val, sizeof( short int ), mode );
  printf( "\n" );

  printf( " \" \" (^)\n\n" );
  new_val = left_val ^ right_val;
  bytes_to_bits( ( char * )&new_val, sizeof( short int ), mode );
  printf( "\n" );

  /* *************************************************************************/

  while ( 1 )
  {
    printf( "   (    -- Enter): " );
    scanf( "%c", &ch );
    
    if ( ch == '\n' )
      break;
    else
    {
      //   ,       '\n'
      scanf( "%*[^\n]" );  //       '\n'
      scanf( "%*c" );      //   '\n'

      bytes_to_bits( ( char * )&ch, sizeof( char ), mode );
    }
  }

  /*         
       scanf()    (   ), 
        fgets()  sscanf().    
           C.
  */
  while ( 1 )
  {
    printf( "    (    -- Enter): " );
    fgets( str, 80, stdin );

    if ( str[ 0 ] == '\n' )   //   Enter,    
      break;
      
    if ( sscanf( str, "%hd", &short_var ) )
      bytes_to_bits( ( char * )&short_var, sizeof( short int ), mode );
    else    //    (, )
      break;
  }

  while ( 1 )
  {
    printf( "   (    -- Enter): " );
    fgets( str, 80, stdin );

    if ( str[ 0 ] == '\n' )   //   Enter,    
      break;

    if ( sscanf( str, "%d", &int_var ) )
      bytes_to_bits( ( char * )&int_var, sizeof( int ), mode );
    else     //    (, )
      break;
  }

  while ( 1 )
  {
    printf( "   float (    -- Enter): " );
    fgets( str, 80, stdin );

    if ( str[ 0 ] == '\n' )   //   Enter,    
      break;

    if ( sscanf( str, "%f", &float_var ) )
      bytes_to_bits( ( char * )&float_var, sizeof( float ), mode );
    else
      break;
  }

  while ( 1 )
  {
    printf( "   double (    -- Enter): " );
    fgets( str, 80, stdin );

    if ( str[ 0 ] == '\n' )   //   Enter,    
      break;

    if ( sscanf( str, "%f", &double_var ) )
      bytes_to_bits( ( char * )&double_var, sizeof( double ), mode );
    else
      break;
  }

  return 0;
}


/*       , 
      .         .
      -- ,     
   ()   .
   
    const     ,   
   ,     bytes,  
    .
*/
void bytes_to_bits( const char *bytes, int bytes_count, unsigned short mode )
{
  // :
  // bytes - ,        
  // bytes_count -     
  // mode -    (   
  //          "")
  //   :
  // PRINT_NUM_BYTE --      
  // PRINT_ADDRESS_BYTE --      
  // PRINT_ONE_BYTE_PER_LINE --      

  unsigned char ch;     //     ,   
                        //  bytes
  unsigned short mask;  //   (),     
                        //   1,      0
  int current_byte;     //    
  int pos;              //      
  
  /*   ,    const,  
       .  
     .     . */
  // *bytes = 4;

  //    
  for ( current_byte = 0; current_byte < bytes_count; current_byte++ )
  {
    //     ,     bytes
    //      current_byte 
    ch = *( bytes + current_byte );

    //  ,         7.
    //    ,     
    //   :
    // mask = 128;
    mask = 1 << 7;   // mask = 0b00000000100000000 (   7)

    //     ,        
    if ( bytes_count > 1 )
    {
      // ,     ,   
      //    (  "").
      if ( mode & PRINT_NUM_BYTE )
        //    ,    ,  current_byte + 1
        printf( " %d ", current_byte + 1 );
    }

    //      
    if ( mode & PRINT_ADDRESS_BYTE )
      printf( "  %p ", bytes + current_byte ); 

    //    ,    , ..   
    // ,     ,    
    //        
    for ( pos = 7; pos >= 0; pos-- )
    {
      //    ,     ,   
      //   ,     ,    
      //   
      // .   printf()    
      //             .
      //      :
      // printf( "%d", ( ch & mask ) );
      printf( "%d", ( ch & mask ) ? 1 : 0 );

      //         
      mask = mask >> 1;
    }

    //        
    if ( mode & PRINT_ONE_BYTE_PER_LINE )
      printf( "\n" );
    else
      printf( " " );   //       
  }

  //        ,     -
  //    
  if ( ! ( mode & PRINT_ONE_BYTE_PER_LINE ) )
    printf( "\n" );

  return;
}
