/* ****************************************************************************
* Программа: основные управляющие конструкции
* Автор:     Е. П. Моргунов
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

/* Это заголовочный файл. Обратите внимание на угловые скобки <> */
#include <stdio.h>

int main( void )
{
  /* объявим переменные */
  int age;            // возраст
  char letter;        // буква латинского алфавита
  
  printf( "Введите ваш возраст (целое число лет): " );
  scanf( "%d", &age );

  /* конструкция if ... else if ... else
     Обратите внимание, что если для какой-либо ветви условного оператора
     предусмотрено выполнение двух операторов и более, то необходимо
     использовать фигурные скобки для оформления блока операторов, как это
     сделано для последней ветви else.
  */
  if ( age < 20 )
    printf( "Вы очень молоды\n" );
  else if ( age < 25 )
    printf( "Вы молоды\n" );
  else if ( age < 30 )
    printf( "Вы не очень молоды\n" );
  else               // &age >= 30 )
  {
    printf( "Что делать... Годы идут.\n" );
    printf( "Не переживайте, а лучше изучайте язык C\n" );
  }

  /* Когда вы вводите число и нажимаете клавишу Enter, то в буфер записывается
     не только это число, но также и символ новой строки. При следующем
     вызове функции scanf() этот символ будет прочитан из буфера, и при этом
     не будет организован ввод с клавиатуры (т. е. курсор на дисплее). Такое
     поведение программы нас в данном случае не устраивает, поэтому мы
     очищаем буфер ввода с помощью обращения к самой функции scanf(). При таком
     способе символы, считанные из буфера, не записываются ни в какую
     переменную или массив.
  */
  scanf( "%*[^\n]" );  // удаляем все символы вплоть до символа '\n'
  scanf( "%*c" );      // удаляем символ '\n'

  printf( "Введите одну из первых 3 букв латинского алфавита: " );
  scanf( "%c", &letter );

  /* здесь используются следующие операции:
     ==  численное сравнение;
     ||  логическое "ИЛИ";
     &&  логическое "И".
     Обратите внимание, что введенные символьные значения заключены
     в одинарные кавычки.
  */ 
  if ( letter == 'a' || letter == 'A' )
    printf( "apple\n" );
  else if ( letter == 'b' || letter == 'B' )
    printf( "banana\n" );
  else if ( letter == 'c' || letter == 'C' )
    printf( "cucumber\n" );
  else
    printf( "I don't know this letter\n" );

  /* То же самое реализуем с использованием еще одной конструкции -- switch.
     В операторах case могут использоваться только данные целого типа (int)
     и символьного типа (char).
  */

  /* очистим буфер ввода, как и в первом случае */
  scanf( "%*[^\n]" );
  scanf( "%*c" ); 

  /* Эти два оператора закомментированы, поскольку буфер ввода уже очищен.
     Если же, наоборот, закомментировать вызовы функции scanf(), находящиеся
     выше, и раскомментировать следующие два оператора, то буфер также будет
     очищен, но иным способом -- путем считывания последнего символа из буфера
     в переменную. Однако такой способ не всегда удобен.
  */
//  scanf( "%c", &letter );
//  printf( "В буфере еще находился символ с ASCII-кодом %d\n", letter );

  printf( "Введите еще раз одну из первых 3 букв латинского алфавита: " );
  scanf( "%c", &letter );

  /* конструкция switch ... case ... case ... default */
  switch ( letter )
  {
    /* когда два оператора case идут один за другим, это аналогично
       логическому оператору "ИЛИ"
    */
    case 'a':
    case 'A':
      printf( "apple\n" );
      /* оператор break передает управление на оператор, следующий за 
         замыкающей фигурной скобкой; если бы оператора break здесь не было,
         то выполнение программы продолжалось бы далее, на ветви "case 'b':" */
      break; 

    case 'b':
    case 'B':
      printf( "banana\n" );
      break;

    case 'c':
    case 'C':
      printf( "cucumber\n" );
      break;

    default:
      printf( "I don't know this letter\n" );
  }

  /* То же самое выполним с помощью условного оператора, который выглядит так:
     "( условие ) ? ( условие выполнено ) : ( условие не выполнено )" );
     Если проверяемое условие удовлетворяется, то выполняется оператор,
     следующий после знака "?", а если условие не удовлетворяется, то
     выполняется оператор, следующий после знака ":". Эти условные операторы
     могут быть вложенными.
   */

  printf( "\nПроделаем то же самое с помощью условного оператора\n\n" );

  /* для повышения удобства чтения исходного текста можно заключать в скобки 
     вторую часть оператора, ту, которая находится после символа ":" */
  ( letter == 'a' || letter == 'A' ) ? printf( "apple\n" ) : 
    ( letter == 'b' || letter == 'B' ) ? printf( "banana\n" ) : 
      ( letter == 'c' || letter == 'C' ) ? printf( "cucumber\n" ) : 
        printf( "I don't know this letter\n" );

  return 0;
}
