/* ****************************************************************************
* Программа: переадресация (перенаправление) стандартного ввода/вывода
* Автор:     Е. П. Моргунов
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

/* Эту программу нужно запускать таким образом:

   prg8 < исходный_файл > файл_копия

   Исходный файл должен быть текстовым. Символы "<" и ">" ОБЯЗАТЕЛЬНЫ.
   Символ "<" означает, что входные данные программа будет получать не
   путем ввода с клавиатуры, а из этого файла. Символ ">" означает, что
   результирующие данные будут выводиться не на экран, а в файл.
   Если в текущем каталоге есть файл prg8.c, то можно выполнить программу так:

   prg8 < prg8.c > prg8_new.c

   Если не указать имя файла для вывода, то вывод будет производиться на экран.
   Например, так:

   prg8 < prg8.c
*/


#include <stdio.h>


int main( void )
{
  // один символ, прочитанный программой со стандартного ввода;
  // обратите внимание, что тип этой переменной int, а не char
  int ch;

  // оператор присваивания "=" возвращает только что присвоенное значение,
  // которое мы можем сравнить с символом EOF, который встретится в потоке
  // при достижении конца файла или при ошибке ввода
  while ( ( ch = getchar() ) != EOF )
  {
    // символ, прочитанный из стандартного потока ввода, мы записываем
    // в стандартный поток вывода, тем самым просто копируя файл
    putchar( ch );
  }

  return 0;
}
