/* ****************************************************************************
* Программа: строковые функции
* Автор:     Е. П. Моргунов
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

#include <stdio.h>

// этот заголовочный файл нужен для функций strlen(), strcpy() и др.
#include <string.h>


int main( void )
{
  // зарезервируем память для наших опытов со строками и строковыми функциями
  char str1[ 80 ];
  char str2[ 80 ];

  // результат сравнения двух символьных строк
  int result;

  char first_name[ 80 ];     // имя
  char last_name[ 80 ];      // фамилия
  float salary;              // зарплата
  
  printf( "Введите ваше имя: " );
  gets( str1 );

  // скопируем введенное имя в другой массив -- str2
  strcpy( str2, str1 );

  printf( "Введите вашу фамилию: " );
  gets( str1 );

  // добавим введенную фамилию вслед за именем в массив str2, но сначала
  // поместим пробел после имени; обратите внимание, что символ "пробел" мы
  // представляем в виде строки, т. е. в двойных кавычках, т. к. параметром
  // функции strcat() должна быть строка (указатель на тип char *)
  strcat( str2, " " );
  strcat( str2, str1 );

  printf( "Ваши имя и фамилия: %s\n\n", str2 );

  printf( "Изучим работу функции strcmp(), " \
          "которая сравнивает символьные строки\n" );
  printf( "Введите первое слово: " );
  gets( str1 );

  printf( "Введите второе слово: " );
  gets( str2 );

  result = strcmp( str1, str2 );

  if ( result == 0 )
    printf( "Строки совпадают\n" );

  // обратите внимание, что если в какой-то ветви условия if ... else if ...
  // только один оператор, то можно не использовать скобки {} для оформления
  // блока операторов
  else
  {
    printf( "Строки не совпадают\n" );
    printf( "Длина первой строки - %d\n", strlen( str1 ) );
    printf( "Длина второй строки - %d\n", strlen( str2 ) );

    if ( result == -1 )
      printf( "Первая строка предшествует второй в алфавитном порядке\n" );
    else if ( result == 1 )
      printf( "Вторая строка предшествует первой в алфавитном порядке\n" );
  }

  printf( "\nИзучим работу функции sprintf(), которая позволяет\n" \
          "скомбинировать несколько элементов в единую строку\n" );

  printf( "Введите ваше имя: " );
  gets( first_name );

  printf( "Введите вашу фамилию: " );
  gets( last_name );

  printf( "Введите вашу зарплату " \
          "(используйте десятичную точку '.', а не ','): " );
  scanf( "%f", &salary );

  // поместим все три компонента в одну строку str1
  // (округлим зарплату до двух знаков после запятой)
  sprintf( str1, "%s %s, зарплата - %.2f", first_name, last_name, salary );

  // выведем единую строку
  printf( "%s\n", str1 );

  return 0;
}
