/* ****************************************************************************
* Программа: список студентов
* Модуль:    заголовочный файл
* Автор:     Е. П. Моргунов
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

// прототипы функций
void groups( void );
void lists( void );


/*
  Используем условную компиляцию для возможной обработки широких символов
  в том случае, когда в операционной системе установлена кодировка UTF-8.
  Команда компиляции будет такой:
  
  gcc -DUTF8 -o ....

  Подробно использование широких символов рассматривается в программе prg18.c.
*/
#ifdef UTF8
  #define  YES L'д'
  #define  NO  L'н'
  #define  FORMAT  "%lc"

  #define  NAME_LEN          61
  #define  GROUP_CODE_LEN    21
  #define  GROUP_DESCR_LEN   101
#else
  #define  YES 'д'
  #define  NO  'н'
  #define  FORMAT  "%c"

  #define  NAME_LEN          31
  #define  GROUP_CODE_LEN    11
  #define  GROUP_DESCR_LEN   51
#endif


// совместим объявление структуры и нового имени для нее

// описание студента
typedef struct student 
{
  char  deleted;                       // признак удаленной записи
  char  group_code[ GROUP_CODE_LEN ];  // шифр группы
  char  last_name[ NAME_LEN ];         // фамилия
  char  first_name[ NAME_LEN ];        // имя
  int   height;                        // рост (в сантиметрах)
  float weight;                        // вес (в килограммах)
} STUDENT;


// описание студенческой группы
typedef struct grp
{
  char deleted;                        // признак удаленной записи
  char group_code[ GROUP_CODE_LEN ];   // шифр группы
  char group_descr[ GROUP_DESCR_LEN ]; // описание группы
} GROUP;

